function P = gs_norm_emp(P,A,mom)
%% NORMALIZATION of polynomials.
%   P = gs_normalize(P,w,lb,ub) return normalized polynomials in P by
%   replacing monomials in A with the given moments instead of computing
%   the integrals.

TEPS=10e-30; % accuracy threshold
digits(32)
disp('Gram-Schmidt NORMALIZATION (moment mode)')

for j = 2:length(P)
    norm=expand(P(j)*P(j));
    for m=length(A):-1:2 % norm of polynomials
        norm=subs(norm,A(m),vpa(mom(m)));
    end
    if abs(vpa(norm))<TEPS, warning(['SMALL integral (gs_norm_emp): ',char(norm)]);
    elseif norm<=0, error(['NEGATIVE integral (gs_norm_emp): ',char(norm)]); 
    else P(j) = expand(P(j)/sqrt(norm));
    end
end

P=expand(P);