
%% 1.) uniform distribution (s=2) 

ND=1;
I= index_basis (ND,3);
K=4; % polynomial order 
N=3; % tensor rank 

% basis & tensor via integration
[PHI,w] = basis(K,[2],'',[-1,1]);
T0 = tensor('TK5_ND1s2_[-1,3]_N3.mat',N,I,PHI,w,[-1,1])
[PHI,w] = basis(K,[2],'norm',[-1,1]); % normalized
T1 = tensor('TK5_ND1s2norm_[-1,3]_N3.mat',N,I,PHI,w,[-1,1])

% construct moments (order N*K)
[mom,momnorm] = moments(12,2,[-1,1]);

% generate basis functions via moment substitution, use same moments for
% tensor computation
[PHI] = basis_emp(K,'',mom);
T2 = tensor_emp('TK5mom_ND1_N3.mat',N,I,PHI,mom) % ==T0
[PHI] = basis_emp(K,'norm',mom);
T3 = tensor_emp('TK5normmom_ND1_N3.mat',N,I,PHI,mom) % ==T1


%% 2.) 2D normal distribution (s=[1,1]), normalized over range [-3,3;-inf,inf]

ND=2;
K=3
I= index_basis (ND,K)
TK=length(I(:,1));

% construct basis & tensor  (integration)
[PHI,w] = basis(K,[1,1],'norm',[-3,3;-inf,inf])
T = tensor('TK10_ND2s1[-3,3;-inf,inf]_N3.mat',N,I,PHI,w,[-3,3;-inf,inf])

% construct moments (order K*N)
mom=zeros(ND,TK); momnorm=zeros(ND,TK);
[mom(1,:),momnorm(1,:)] = moments(9,1,[-3,3]);
[mom(2,:),momnorm(2,:)] = moments(9,1,[-inf,inf]);
vpa(mom,3)
vpa(momnorm,3)

% construct basis & tensor (moment subs)
[PHI] = basis_emp(K,'norm',mom)
T = tensor_emp('TK10emp_ND2s1_[-3,3;-inf,inf]_N3.mat',N,I,PHI,mom)


