function P = gs_norm(P,w,b)
%% NORMALIZATION of polynomials.
%   P = gs_norm(P,w,b) normalizes polynomials in P by integration.

TEPS=10e-20;
digits(32)


disp('Gram-Schmidt NORMALIZATION (integration mode)')
xi=symvar(P);
for j = 2:length(P)
    norm=vpa(int(expand(P(j)*P(j))*w,xi,b(1),b(2)));
    if abs(norm)<TEPS, warning(['SMALL integral (gs_norm): ',char(norm)]);
    elseif norm<=0, error(['NEGATIVE integral (gs_norm): ',char(norm)]);     
    else P(j) = expand(P(j)/sqrt(norm));
    end
end

P=expand(P);