function P = gs_ortho(P,w,b)
%% BASIS Polynomial chaos basis constrauction.
%   P = gs_orthogonalize(P,w,lb,ub) return polynomials P orthogonalized wrt.
%   weight function w over [lb,ub].

digits(32)
TEPS=10e-20;

disp('Gram-Schmidt ORTHOGONALIZATION (integration mode)')
xi=symvar(P);

for j = 1:length(P)
    x = P(j);
    for i = 1:j-1
        norm=vpa(expand(P(i)*P(i)));
        norm=vpa(int(norm*w,xi,b(1),b(2)));
        fac=vpa(expand(x*P(i)));
        fac=int(fac*w,xi,b(1),b(2));
        if abs(norm)<TEPS, warning(['SMALL integral (gs_ortho): ',char(norm)]);
        elseif norm<=0, error(['NEGATIVE integral (gs_ortho): ',char(norm)]);     
        else temp=fac/norm;
        end
        x = x - temp*P(i);
    end
    P(j) =expand(x);
end

P=expand(P);