function I= index_basis (d ,K)
%% INDEX_BASIS compute multiindex for monomials of degree K with d variables
%   M= INDEX_BASIS (d ,K) returns MD basis index set as matrix M with d columns 
%   and P=perm(d,K)=(d+K,d) rows, given maximum polynomial degree K
%
%   Each row M(i,:) represents the i-th MD polynomial for i = 1,..., P
%   For each row i, the entry M(i,j) is the exponent of the j -th variable 
%   x_j for i = 1,..., P Mnd j = 1,..., d
%   (See also Occupancy problem: placing K balls into d cells)
%
%   Used for basis index generation

I (1 ,1: d )= zeros (1 , d); % 0th order polynomial
I (2: d +1 ,1: d )= eye (d , d); %1st order polynomials

P= d +1;
pmat =[];
pmat(1: d ,1)=1;

for k =2: K
    L= P;
    for i =1: d
        pmat (i ,k )= sum ( pmat (i:d ,k -1));
    end
    for j =1: d
        for m =L - pmat (j , k )+1: L
            P= P +1;
            I(P ,1: d )= I(m ,1: d);
            I(P , j )= I(P ,j )+1;
        end
    end
end

end
