function [S,SD] = pce_build(SD,I,s,ext,b)
%% BUILD PCE expansion

TK=length(I(:,1));
NXD=length(SD(1,:))/TK;
[PHI,~,~] = basis(max(I(:,1)),s,ext,b);
Phi = sym('Phi',[1 TK]);
X = sym('X',[1 TK]);
PCE=sym('P',[1 TK]);
assumeAlso(Phi,'real');
Xpce = dot(X,Phi);
for k=1:TK
    PCE(k)=1;
    for d=1:length(s)
        PCE(k)=PCE(k)*PHI(I(k,d)+1,d);
    end
end
Xpce=subs(Xpce,Phi,PCE);

S = sym('S',[length(SD(:,1)) NXD]);
for i=1:NXD
    for n=1:length(SD(:,1))
        S(n,i) = subs(Xpce,X,SD(n,i:NXD:end));
    end
end

end