function [S,U,O] = read_solution(fname,IND,M)
%% READ SOLUTION trajectories from muscod txt-file
%
% INPUT: state specified in IND
% OUTPUT: solution values of state trajectoreis (T) and o.f. (O)


if ~exist('M','var'), M=500; end % Ngrid+1
if ~exist('IND','var'), IND=0:200; end % IND can be used to read only subset of values
format long
fid = fopen(fname,'r');
i=1; m=1;
while ~feof(fid)
    line = fgets(fid);
    if length(line)>2 & strcmp(line(1:3),'obj')
        line = fgets(fid);
        O=sscanf(line,'  %e');
        if IND(1)==-1, return; end
    end
    if length(line)>4
        if strcmp(line(1:5),'sd(0,')
            p=1;
            while length(line)>1 && p<=length(IND)
                line = fgets(fid);
                ll=length(num2str(IND(p)));
                switch ll
                    case 1, space='  ';
                    case 2, space=' ';
                    otherwise, space='';
                end
                if length(line)>3 && strcmp(line(1:ll+1+length(space)),[space,num2str(IND(p)),':'])
                    S(i,p)=sscanf(line,[space,num2str(IND(p)),':   %e']);
                    p=p+1;
                end
                %if p>N, p=1; end
            end
            i=i+1;
        end
    end
    if length(line)>5 && m<=M
        if strcmp(line(1:3),'u(0') || strcmp(line(1:3),'ue(')
            s=sscanf(fgets(fid),['  0:   %e']);
            if isempty(s),m=m+1;continue; end
            U(m,1)=s;
            s=sscanf(fgets(fid),['  1:   %e']);
            if isempty(s),m=m+1;continue; end
            U(m,2)=s;
            s=sscanf(fgets(fid),['  2:   %e']);
            if isempty(s),m=m+1;continue; end
            U(m,3)=s;  
            %line = fgets(fid);
            m=m+1;continue;
        end
    end
end 
fclose(fid);

%% how to read MAT file
% if strcmp(name(end-2:end),'mat')
%     load(name,'iterations')
%     SD = cell2mat(iterations{end}.finalvar.sd);
%     if isfield(iterations{1},'varsca')
%         SC = cell2mat(iterations{1}.varsca.sd);
%         SD=SD.*SC; % unscale (as MUSCOD plots)
%     end
%     %if isfield(iterations{end},'info'), obj = iterations{end}.info.obj; end
% elseif strcmp(name(end-2:end),'txt'),[SD,~] = readTextSolution(name);
% end