function F = ccrane(s,ext,b,I)
%% Container crane - problem file

if ~exist('s','var'),s=[1,1]; end
if ~exist('ext','var'),ext=''; end
if ~exist('b','var'),b=[]; end

%% model specification
NXD = 6;
NXA=0;
xd = sym('xd',[1 NXD]);
xdd = sym('xdd',[1 NXD]);
xa = sym('xa',[1 NXA]);
u = sym('u',[1 2]);
p=sym('p',[1 1]);

% Write equations as implicit ODE (must be polynomial in all uncertain
% quantities)
f(1) = xd(4) - xdd(1);
f(2) = xd(5) - xdd(2);
f(3) = xd(6) - xdd(3);
f(4) = u(1) + p(1)*1.76*9.81*xd(3) - xdd(4);
f(5) = u(2) - xdd(5);
f(6) = -u(1) - (1.0+p(1)*1.76)*9.81*xd(3) - 2*xd(5)*xd(6) -  xd(2)*xdd(6);

% Example objective function
h = 0.5 * (xd(3)*xd(3) + xd(6)*xd(6));

% highest polynomial degree (wrt. all uncertain variables)
NL=2; 

% 2D uncertainty (e.g. uncertain parameter + uncertain initial state) 
K=3; I=index_basis(length(s),K);  % full basis
%I=[0,0;1,0;0,1;2,0;1,1;0,2;3,0;0,3] % partial basis

%% transform equations
I=index_basis(length(s),K); 
F = pce_setup(mfilename,f,xd,xdd,xa,p,NL,I,s,ext,b);
H = pce_setup(mfilename,h,xd,xdd,xa,p,NL,I,s,ext,b);


