function F = vdpol(s,ext,b,I)
%% Van-der-Pol oscillator - problem file

if ~exist('s','var'),s=[1]; end
if ~exist('ext','var'),ext=''; end
if ~exist('b','var'),b=[]; end

%% model specification
NXD = 2;
NXA = 0;
xd = sym('xd',[1 NXD]);
xdd = sym('xdd',[1 NXD]);
xa = sym('xa',[1 NXA]);
p = sym('p',[1 1]);
u = sym('u',[1 1]);

% Write equations as implicit ODE (must be polynomial in all uncertain
% quantities)
f(1) = xd(2) - xdd(1); 
f(2) = -xd(1) + p(1)*xd(2)*(1-xd(1)*xd(1)) + u(1) - xdd(2);

% Example objective function 
h(1) = 0.5*(xd(1)*xd(1) + xd(2)*xd(2) + u(1)*u(1));

% highest polynomial degree (wrt. all uncertain variables)
NL=4; 
K=5;
I=index_basis(length(s),K);

%% transform equations (written to output files)
F = pce_setup(mfilename,f,xd,xdd,xa,p,NL,I,s,ext,b);
H = pce_setup(mfilename,h,xd,xdd,xa,p,NL,I,s,ext,b);

